#ifndef _BIC_H_
#define _BIC_H_

#include "curve.h"
#include "image.h"
#include "cimage.h"
#include "adjacency.h"

#define LOW 0
#define HIGH 1
#ifndef FALSE
#define FALSE 0
#endif
#ifndef TRUE
#define TRUE 1
#endif

#define DESC_SIZE 64

/* data structure used to extract BIC descriptor */
typedef struct {
  int color;
  int frequency;
}Property;

typedef struct {
  unsigned long colorH[DESC_SIZE];
  unsigned long lowH[DESC_SIZE];
  unsigned long highH[DESC_SIZE];
}VisualFeature;

typedef struct {
  unsigned char colorH[DESC_SIZE];
  unsigned char lowH[DESC_SIZE];
  unsigned char highH[DESC_SIZE];
}CompressedVisualFeature;


/**********************************************/
/* BIC */

Curve *BIC(CImage *img);
void Write_visual_features(char *filename,char *dbname, CompressedVisualFeature *cvf);
CompressedVisualFeature *Extract_visual_features(CImage *img);
double gray_level_BIC(Image *img1, Image *img2);
#endif
