#include <stdio.h>
#include <stdlib.h>
#include <string.h>
#include <dirent.h>

typedef struct _buf { /* Buffer de leitura dos arquivos dLog.txt */
	float d;
	char fname[20];
	char img_name[50];
} BUF;

typedef struct _pxr { /* Precision x Recall */
	float prec;
	float rec;
} PXR;

char folder[100], file_name[50];
int n, m, count;
BUF buf[3000][3000];
PXR pxr[3000][3000];
PXR media_pxr[3000];

int isDir(char *dir) {
	if (strcmp(dir, ".") != 0 && strcmp(dir, "..") != 0)
		return 1;
	else
		return 0;
}

void get_dLog_values(char *src) {
	struct dirent *folder_dlog, *file_dLog;
	DIR *list_folders, *list_files;
	FILE *file;
	/*BUF buf[3000][3000];*/

    n = 0;
	list_folders = opendir(src);
	while ((folder_dlog = readdir(list_folders)) != NULL) {
		
		if (isDir(folder_dlog->d_name)) {
			m = sprintf(folder, "%s/%s", src, folder_dlog->d_name);
			
		    list_files = opendir(folder);
			while ((file_dLog = readdir(list_files)) != NULL) {
				if (isDir(file_dLog->d_name)) {
					m = sprintf(file_name, "%s/%s", folder, file_dLog->d_name);
					
					file = fopen(file_name, "r");
					if (file == NULL) printf("ERRO!!\n");
					else {
						printf("Abriu o arquivo %s\n", file_name);
						for(m=0; (fscanf(file,"%f %s", &(buf[n][m].d), buf[n][m].img_name)) != EOF; m++) {
							strcpy(buf[n][m].fname, folder_dlog->d_name);
						}
						fclose(file);
						n++;
					}
				}
			}
			closedir(list_files);
		}
	}
	closedir(list_folders);

	printf("n: %d\n", n);
	printf("m: %d\n", m);
}

void precision_recall() {
	char *split;
	int i, j;
	int count_prec, count_rec;

	for (i = 0, count = 0; i < n; i++) {
		count_prec = 0; count_rec = 0;
		for (j = 0; j < m; j++) {
			split = strtok (buf[i][j].img_name, "-");
			if (split != NULL) {
				if (strcmp(split, buf[i][j].fname) == 0) {
					/*printf("Acertou: %s \n", split);*/
					count_prec++;
					count_rec++;
					pxr[i][j].prec = count_prec*(1.0) / count_rec*(1.0);
					pxr[i][j].rec  = count_rec*(1.0) / m*(1.0);
				}
				else {
					/*printf("Errou: %s \n", split);*/
					count_rec++;
					pxr[i][j].prec = count_prec*(1.0) / count_rec*(1.0);
					pxr[i][j].rec  = count_rec*(1.0) / m*(1.0);
				}
			}
            count++;
		}
	}
}

void media_precision_recall() {
	int i, j;

	for (j = 0; j < m; j++) {
		media_pxr[j].prec = 0.0;
		media_pxr[j].rec  = 0.0;
		for (i = 0; i < n; i++) {
			/*printf("pxr[%d][%d].prec: %f, pxr[%d][%d].rec: %f\n", i, j, pxr[i][j].prec, i, j, pxr[i][j].rec);*/
			media_pxr[j].prec += pxr[i][j].prec;
			media_pxr[j].rec  += pxr[i][j].rec;
		}

		media_pxr[j].prec /= n;
		media_pxr[j].rec  /= n;

		/*printf("media_pxr[%d].prec: %f, media_pxr[%d].rec: %f\n", j, media_pxr[j].prec, j, media_pxr[j].rec);*/
	}
}

void create_file_precision_recall(char *src) {
	int j;
	FILE *file;

	j = sprintf(file_name, "media_precision_recall.txt");

	file = fopen(file_name, "w");
	if (file == NULL) printf("ERRO!!\n");
	else {
		for (j = 0; j < m; j++) {
			fprintf(file, "%f %f\n", media_pxr[j].prec, media_pxr[j].rec);
			/*fprintf(file, "(%f,%f) \\\\ \n", media_pxr[j].rec, media_pxr[j].prec);*/
		}
	}
}


int main(int ac, char **av) {
	int i, j;

    /* Lê os arquivos que contém as distâncias dLog */
	get_dLog_values(av[1]);
	/* Calcula o precision x recall de cada arquivo que contém as distâncias dLog. */
	precision_recall();
	/* Calcula a média dos precision x recall dada pela função precision_recall(). */
	media_precision_recall();
	/* Cria o arquivo e insere a media dos precision x recall dado pela função media_precision_recall(). */
	create_file_precision_recall(av[2]);

	/*for (i = 0; i < n; i++) {
		for (j = 0; j < m; j++) {
			printf("pxr[%d][%d].prec: %f, pxr[%d][%d].rec: %f\n", i, j, pxr[i][j].prec, i, j, pxr[i][j].rec);
		}
	}*/

	printf("\nNumero de leituras: %d\n", count);

	return 0;
}