#include <stdio.h>
#include <stdlib.h>
#include <string.h>
#include <dirent.h>
#include <iostream>

extern "C" {

#include "BIC/include/libs.h"

}

/*========================================================================
	Estruturas e funções de pré-processamento da imagem
 ========================================================================*/

typedef struct _dist { /* Distancia */
	float d;
	char img_name[100];
} Dist;

FILE *file;
Dist dist[5000];
char folder[100], mkdir[100];
CImage *ci1=NULL, *ci2=NULL;
Curve *cv1=NULL, *cv2=NULL;


int isDir(char *dir) {
	if (strcmp(dir, ".") != 0 && strcmp(dir, "..") != 0)
		return 1;
	else
		return 0;
}

int count_images(char *path) {
    struct dirent *list_dir, *list_img;
    DIR *all_dir, *dir_img;
    char img[50]; 
    int m, n = 0;

    all_dir = opendir(path);
	while ((list_dir = readdir(all_dir)) != NULL) {
		if (isDir(list_dir->d_name)) {
			m = sprintf(img, "%s/%s", path, list_dir->d_name);
			dir_img = opendir(img);
			while ((list_img = readdir(dir_img)) != NULL) {
				if (isDir(list_img->d_name)) n++;
			}
			closedir(dir_img);
		}
	}
	closedir(all_dir);

	return n;
}

void create_dir(char *src) {
	char aux[20], *split;
	int i, m;

	strcpy(mkdir, "mkdir dLog");
	strcpy(folder, src);
    split = strtok (folder, "/");

    for (i = 0; split != NULL; i++) {
		if (i >= 2) {
			strcat(mkdir, "/");
			strcat(mkdir, split);
			system(mkdir);
			split = strtok (NULL, "/");
		}
		else split = strtok (NULL, "/");
	}

	printf ("mkdir: %s\n", mkdir);

	sscanf(mkdir, "%s %s", aux, folder);
	//strcpy(folder, split);
	//m = sprintf(mkdir, "mkdir dLog/%s", folder);
    system(mkdir);
}

void create_curve(char *path, char *image, int image_id) {
	char src_img[100];
	int m;

	m = sprintf(src_img, "%s/%s", path, image);
	if (image_id == 1) {
		ci1 = ReadCImage(src_img);
		cv1 = BIC(ci1, src_img);
	}
	else if (image_id == 2) {
		ci2 = ReadCImage(src_img);
		cv2 = BIC(ci2, src_img);
	}
	//printf("\n%s\n", src_img);
}

void destroy_curve(int image_id) {

	if (image_id == 1) {
		DestroyCImage(&ci1);
		DestroyCurve(&cv1);
	}
	else if (image_id == 2) {
		DestroyCImage(&ci2);
		DestroyCurve(&cv2);
	}
}

void create_file(char *image) {
	char files[50];
	int m;

	m = sprintf(files, "%s/%s.txt", folder, image);
	//printf("%s\n", files);
	file = fopen(files, "w");
}

/* Calcula a distância dLog entre duas curvas */
float dLog (Curve *cv1, Curve *cv2) {
	int i;
	float aux;
	float f1, f2, f = 0.0;

	for (i = 0; i < 2*DESC_SIZE; i++) {
		f1 = cv1->Y[i];
		f2 = cv2->Y[i];
		aux = f1 - f2;
		if (aux < 0) aux *= -1.0;
		f += aux;
	}

	return f;
}

int compare (const void * a, const void * b)
{
	Dist *ia = (Dist *)a;
    Dist *ib = (Dist *)b;

    return (int) (100.f*ia->d - 100.f*ib->d);
	/* float comparison: returns negative if b > a 
	and positive if a > b. We multiplied result by 100.0
	to preserve decimal fraction */ 
}

int main(int ac, char **av) {
	char src_img[100];
	struct dirent *list_dir, *list_img1, *list_img2;
    DIR *all_dir, *dir_img1, *dir_img2;
    int k, n, m, count;

    n = count_images(av[2]);
    create_dir(av[1]);

	printf("\n================== %s ==================\n\n", av[1]);
	count = 1;
	// Varre um único diretório de imagem (classe) para o processamento. */
	dir_img1 = opendir(av[1]);
	while ((list_img1 = readdir(dir_img1)) != NULL) {
		if (isDir(list_img1->d_name)) {
			create_file(list_img1->d_name);
			create_curve(av[1], list_img1->d_name, 1);
			printf("Prossessando %s --(%d)--> ", list_img1->d_name, count);
			// Varre todos os diretórios de imagem (classes) em busca de imagens,
			// que serão usadas para compara-las com a imagem selecionada do loop acima.
			k = 0; count++;
			all_dir = opendir(av[2]);
			while ((list_dir = readdir(all_dir)) != NULL) {
				if (isDir(list_dir->d_name)) {
					m = sprintf(src_img, "%s/%s", av[2], list_dir->d_name);
					dir_img2 = opendir(src_img);
					while ((list_img2 = readdir(dir_img2)) != NULL) {
						if (isDir(list_img2->d_name)) {
							//calculate_distance(src_img, list_img2->d_name, k);
							create_curve(src_img, list_img2->d_name, 2);
							dist[k].d = dLog(cv1, cv2);
							strcpy(dist[k].img_name, list_img2->d_name);
							//printf("\n%s -- %s | dist[%d] : %f\n", list_img1->d_name, list_img2->d_name, k, dist[k].d);
							destroy_curve(2);
						    k++;
						}
					}
					closedir(dir_img2);
				}
			}
			qsort (dist, n, sizeof(Dist), compare);
			for (k=0; k < n; k++) { fprintf(file, "%f %s\n", dist[k].d, dist[k].img_name); }
			destroy_curve(1);
			closedir(all_dir);
			fclose(file);
			printf(" %s processado\n", list_img1->d_name);
		}
	}
	closedir(dir_img1);


	printf("\n---------------------------- Terminado ----------------------------\n\n");

	return 0;
}